# norootforbuild

%define major     0
%define lib       libffmpeg
%define libname   %{lib}%{major}
%define majoravcodec     52
%define libavcodec       libavcodec
%define libnameavcodec   %{libavcodec}%{majoravcodec}
%define majoravdevice    52
%define libavdevice      libavdevice
%define libnameavdevice  %{libavdevice}%{majoravdevice}
%define majoravformat    52
%define libavformat      libavformat
%define libnameavformat  %{libavformat}%{majoravformat}
%define majoravutil      50
%define libavutil        libavutil
%define libnameavutil    %{libavutil}%{majoravutil}
%define majorpostproc    51
%define libpostproc      libpostproc
%define libnamepostproc  %{libpostproc}%{majorpostproc}
%define majorswscale     0
%define libswscale       libswscale
%define libnameswscale   %{libswscale}%{majorswscale}
%define lastrelease      0.5
%define svnsnapshot      23289
%define majoravfilter	1
%define libavfilter	libavfilter
%define libnameavfilter	%{libavfilter}%{majoravfilter}

Name:           ffmpeg
Version:        %{lastrelease}.%{svnsnapshot}svn
Release:        9.12
License:        LGPL v2 or later and some code GPL v2 or later
Group:          Productivity/Multimedia/Video/Editors and Convertors
Summary:        Hyper fast MPEG1/MPEG4/H263/RV and AC3/MPEG audio encoder
Summary(de):    Hyperschneller MPEG1/MPEG4/H263/RV Und AC3/MPEG Audio-Encoder
URL:            http://ffmpeg.mplayerhq.hu
Source0:        ffmpeg-%{version}.tar.bz2
Patch0:         ffmpeg_configure.diff
Patch1:         ffmpeg_fix_return.diff
Patch2:		configure-openjpeg.patch
BuildRoot:      %{_tmppath}/%{name}-buildroot
Requires:       %{libnameavcodec} = %{version}-%{release}
Requires:       %{libnameavdevice} = %{version}-%{release}
Requires:       %{libnameavformat} = %{version}-%{release}
Requires:       %{libnameavutil} = %{version}-%{release}
Requires:       %{libnameswscale} = %{version}-%{release}
BuildRequires:  libdca-devel
BuildRequires:  libdca0
BuildRequires:  yasm >= 1.0.1
BuildRequires:  libgsm
BuildRequires:  libgsm-devel
BuildRequires:  imlib2-devel
BuildRequires:  libmp3lame-devel
BuildRequires:  libogg-devel
BuildRequires:  libvorbis-devel
BuildRequires:  libtheora-devel >= 1.1
BuildRequires:  ncurses-devel
BuildRequires:  libjack-devel
BuildRequires:  alsa-lib-devel
BuildRequires:  freetype-devel
BuildRequires:  SDL-devel
BuildRequires:  slang-devel
BuildRequires:  xorg-x11-proto-devel xorg-x11-xtrans-devel
BuildRequires:  zlib-devel
BuildRequires:	bzip2-devel
BuildRequires:  libfaad2 >= 2.7
BuildRequires:  libfaad-devel >= 2.7
BuildRequires:  libfaac-devel >= 1.28
BuildRequires:  libx264-devel >= 0.95svn20100517
BuildRequires:  libxvidcore-devel
BuildRequires:  libmp4v2-devel
BuildRequires:  texinfo
BuildRequires:  libopencore-amr-devel
BuildRequires:  liba52-devel
BuildRequires:  libdc1394
BuildRequires:  libdc1394-devel
BuildRequires:  libspeex-devel
BuildRequires:  libschroedinger-devel >= 1.0.5
BuildRequires:  liboil-devel >= 0.3.15
BuildRequires:  libdirac-devel >= 1.0.0
BuildRequires:	librtmp-devel
#%if 0%{?suse_version} >= 1100
#BuildRequires:  libnut-devel
#%endif
%if 0%{?suse_version} > 1020
BuildRequires:  libdc1394_control12-devel
%endif
#BuildRequires:  G.729-devel
BuildRequires:  libopenjpeg-devel
BuildRequires:  libvdpau-devel
BuildRequires:	texi2html

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

%description -l de
ffmpeg ist ein hyperschneller realtime Audio-/Video-Encoder, ein Streaming
Server und ein Audio und Video Dateikonverter.

Es kann von einer Standard-Video4Linux-Quelle grabben und in verschiedene
Dateiformate basierend auf einer DCT/motion compensation konvertiern.
Sound wird in einen MPEG audio layer 2 oder AC3 Stream geschrieben.

%package -n %{libname}
Group:          System/Libraries
Summary:        Metapackage for ffmpeg shared libraries
Summary(de):    Metapaket für die ffmpeg Bibliotheken
Requires:       %{libnameavcodec} = %{version}-%{release}
Requires:       %{libnameavdevice} = %{version}-%{release}
Requires:       %{libnameavformat} = %{version}-%{release}
Requires:       %{libnameavutil} = %{version}-%{release}
Requires:       %{libnamepostproc} = %{version}-%{release}
Requires:       %{libnameswscale} = %{version}-%{release}

%description -n %{libname}
Metapackage for ffmpeg shared libraries.
For compatibility reasons only.

%description -n %{libname} -l de
Metapaket für die ffmpeg Bibliotheken.
Das Paket existiert nur noch aus Kompatibilitätsgründen.

%package -n %{libnameavcodec}
Group:          System/Libraries
Summary:        Ffmpeg %{libavcodec}
Provides:       %{libavcodec} = %{version}-%{release}

%description -n %{libnameavcodec}
ffmpeg %{libavcodec} shared library

%description -n %{libnameavcodec} -l de
ffmpeg %{libavcodec} Bibliothek


%package -n %{libnameavdevice}
Group:          System/Libraries
Summary:        Ffmpeg %{libavdevice}
Provides:       %{libavdevice} = %{version}-%{release}

%description -n %{libnameavdevice}
ffmpeg %{libavdevice} shared library

%description -n %{libnameavdevice} -l de
ffmpeg %{libavdevice} Bibliothek


%package -n %{libnameavformat}
Group:          System/Libraries
Summary:        Ffmpeg %{libavformat}
Provides:       %{libavformat} = %{version}-%{release}

%description -n %{libnameavformat}
ffmpeg %{libavformat} shared library

%description -n %{libnameavformat} -l de
ffmpeg %{libavformat} Bibliothek


%package -n %{libnameavutil}
Group:          System/Libraries
Summary:        Ffmpeg %{libavutil}
Provides:       %{libavutil} = %{version}-%{release}

%description -n %{libnameavutil}
ffmpeg %{libavutil} shared library

%description -n %{libnameavutil} -l de
ffmpeg %{libavutil} Bibliothek


%package -n %{libnamepostproc}
Group:          System/Libraries
Summary:        Ffmpeg %{libpostproc}
Provides:       %{libpostproc} = %{version}-%{release}

%description -n %{libnamepostproc}
ffmpeg %{libpostproc} shared library

%description -n %{libnamepostproc} -l de
ffmpeg %{libpostproc} Bibliothek


%package -n %{libnameswscale}
Group:          System/Libraries
Summary:        Ffmpeg %{libswscale}
Provides:       %{libswscale} = %{version}-%{release}

%description -n %{libnameswscale}
ffmpeg %{libswscale} shared library

%description -n %{libnameswscale} -l de
ffmpeg %{libswscale} Bibliothek

%package -n %{libnameavfilter}
Group:		System/Libraries
Summary:	FFmpeg %{libavfilter}
Provides:	%{libavfilter} = %{version}-%{release}

%description -n %{libnameavfilter}
ffmpeg %{libavfilter} shared library

%description -n %{libnameavfilter} -l de
ffmpeg %{libavfilter} Bibliothek

%package -n %{lib}-devel
Group:          Development/Libraries/C and C++
Summary:        Header files and static library for the ffmpeg library
Summary(de):    Header Dateien und statische Bibliotheken für die ffmpeg Bibliothek
Requires:       %{libname} = %{version}-%{release}
Requires:       libmp3lame-devel
Requires:       libogg-devel
Requires:       libvorbis-devel
Requires:       libtheora-devel >= 1.1
Requires:       alsa-lib-devel
Requires:       slang-devel
Requires:       zlib-devel
Requires:	bzip2-devel
Requires:       libfaad-devel
Requires:       libfaac-devel
Requires:       libxvidcore-devel
Requires:       libmp4v2-devel
Requires:       libx264-devel >= 0.95svn20100517
Requires:       libopencore-amr-devel
Requires:       liba52-devel
Requires:       libjack-devel
Requires:       libspeex-devel
Requires:       libdca-devel
Requires:       libgsm-devel
Requires:       libdc1394
Requires:       libdc1394-devel
Requires:       libschroedinger-devel >= 1.0.5
Requires:       liboil-devel >= 0.3.15
Requires:       libdirac-devel >= 1.0.0
#%if 0%{?suse_version} >= 1100
#Requires:       libnut-devel
#%endif
%if 0%{?suse_version} > 1020
Requires:       libdc1394_control12-devel
%endif
Requires:       libopenjpeg-devel
Requires:       libvdpau-devel
Provides:       %{libname}-devel = %{version}-%{release}
%ifarch x86_64 amd64 ia32e
Provides:       libavcodec.so()(64bit)
Provides:       libavformat.so()(64bit)
Provides:       libavutil.so()(64bit)
Provides:       libpostproc.so()(64bit)
Provides:	libavfilter.so()(64bit)
%else
Provides:       libavcodec.so
Provides:       libavformat.so
Provides:       libavutil.so
Provides:       libpostproc.so
Provides:	libavfilter.so
%endif
Obsoletes:      ffmpeg-devel < %{version}
Provides:       ffmpeg-devel = %{version}

%description -n %{lib}-devel
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

Install libffmpeg-devel if you want to compile apps with ffmpeg support.

%description -n %{lib}-devel -l de
ffmpeg ist ein hyperschneller realtime Audio-/Video-Encoder, ein Streaming
Server und ein Audio und Video Dateikonverter.

Es kann von einer Standard-Video4Linux-Quelle grabben und in verschiedene
Dateiformate basierend auf einer DCT/motion compensation konvertiern.
Sound wird in einen MPEG audio layer 2 oder AC3 Stream geschrieben.

Installieren Sie libffmpeg-devel wenn Sie Anwendungen mit ffmpeg Support
compilieren wollen.

%debug_package

%prep
%setup -q -n %{name}
%patch0
%patch1 -p1
%patch2
sed -i -e "s/UNKNOWN/SVN-r%{svnsnapshot}/g" version.sh
%if 0%{?suse_version}
%suse_update_libdir configure
%endif
#don't call ldconfig on install
#perl -pi -e 's/ldconfig \|\| true//' libavcodec/Makefile

%build
archflags=""
%ifarch x86_64 amd64 ia32e
  archflags=" -fPIC"
%endif
%ifarch %ix86
#  archflags=" -pipe -ffast-math -fomit-frame-pointer -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
  archflags=" -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
  sed -i -e "s/-fPIC -DPIC//g" libpostproc/Makefile
%endif

CFLAGS="$RPM_OPT_FLAGS $archflags -I%{_includedir}/gsm"
export archflags
export CFLAGS

./configure --shlibdir=%{_libdir} --prefix=%{_prefix} --mandir=%{_mandir} \
            --libdir=%{_libdir} --enable-shared --enable-libmp3lame \
            --enable-libvorbis --enable-libtheora --enable-libspeex \
            --enable-libfaad --enable-libfaac --enable-nonfree --enable-libxvid \
            --enable-postproc --enable-gpl --enable-x11grab \
            --enable-libschroedinger --enable-libdirac \
            --enable-libgsm \
%ifarch ppc
            --disable-altivec \
%endif
            --enable-version3 --enable-libopencore-amrnb --enable-libopencore-amrwb \
            --enable-libx264 --enable-libdc1394 --enable-pthreads --enable-avfilter \
	    --enable-bzlib \
	    --enable-zlib \
            --enable-libopenjpeg \
            --enable-librtmp \
            --enable-libschroedinger || cat config.err
#--enable-libg729a --enable-liba52 --enable-libopenjpeg --enable-vhook
# --enable-swscale --enable-vdpau
#%if 0%{?suse_version} >= 1100
#            --enable-libnut \
#%endif
%{__make} %{?jobs:-j%{jobs}}

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}
mkdir %{buildroot}
%{__ln_s} libavformat libav
%{__make} DESTDIR=%{buildroot} install

%{__mkdir_p} %{buildroot}%{_includedir}/postproc
%{__install} -d %{buildroot}%{_libdir}/libavcodec
%{__rm} -rf doc/.svn
%{__rm} -f doc/Makefile
%{__rm} -f doc/texi2pod.pl
%{__install} -m 644 libavcodec/dvdata.h %{buildroot}%{_includedir}/libavcodec/
pushd %{buildroot}%{_libdir}/libavcodec && %{__ln_s} -f ../libavcodec.a && popd
echo "Dummy package with dependencies to the real libs" > libffmpeg0.txt

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%post -n %{libnameavcodec} -p /sbin/ldconfig
%postun -n %{libnameavcodec} -p /sbin/ldconfig

%post -n %{libnameavdevice} -p /sbin/ldconfig
%postun -n %{libnameavdevice} -p /sbin/ldconfig

%post -n %{libnameavformat} -p /sbin/ldconfig
%postun -n %{libnameavformat} -p /sbin/ldconfig

%post -n %{libnameavutil} -p /sbin/ldconfig
%postun -n %{libnameavutil} -p /sbin/ldconfig

%post -n %{libnamepostproc} -p /sbin/ldconfig
%postun -n %{libnamepostproc} -p /sbin/ldconfig

%post -n %{libnameswscale} -p /sbin/ldconfig
%postun -n %{libnameswscale} -p /sbin/ldconfig

%post -n %{libnameavfilter} -p /sbin/ldconfig
%postun -n %{libnameavfilter} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc Changelog COPYING.* CREDITS INSTALL MAINTAINERS README doc
%{_bindir}/*
#%{_libdir}/vhook
%{_mandir}/man1/*
%{_datadir}/ffmpeg

%files -n %{libname}
%defattr(-,root,root)
%doc libffmpeg0.txt

%files -n %{libnameavcodec}
%defattr(-,root,root)
%{_libdir}/%{libavcodec}.so.%{majoravcodec}*

%files -n %{libnameavdevice}
%defattr(-,root,root)
%{_libdir}/%{libavdevice}.so.%{majoravdevice}*

%files -n %{libnameavformat}
%defattr(-,root,root)
%{_libdir}/%{libavformat}.so.%{majoravformat}*

%files -n %{libnameavutil}
%defattr(-,root,root)
%{_libdir}/%{libavutil}.so.%{majoravutil}*

%files -n %{libnamepostproc}
%defattr(-,root,root)
%{_libdir}/%{libpostproc}.so.%{majorpostproc}*

%files -n %{libnameswscale}
%defattr(-,root,root)
%{_libdir}/%{libswscale}.so.%{majorswscale}*

%files -n %{libnameavfilter}
%defattr(-,root,root)
%{_libdir}/%{libavfilter}.so.%{majoravfilter}*

%files -n %{lib}-devel
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/*.*a
%{_libdir}/libavcodec
%{_libdir}/pkgconfig/*.pc

%changelog
* Wed May 05 2010 Carsten Schoene <cs@linux-administrator.com> - 0.5.22965svn-3
- EL5 import
